commit 33b11c6d9a600fac25b7cc714e9905aac049685b
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Fri Aug 16 15:37:50 2024 +0100

    aarch64: Fix bogus cnot optimisation [PR114603]
    
    aarch64-sve.md had a pattern that combined:
    
            cmpeq   pb.T, pa/z, zc.T, #0
            mov     zd.T, pb/z, #1
    
    into:
    
            cnot    zd.T, pa/m, zc.T
    
    But this is only valid if pa.T is a ptrue.  In other cases, the
    original would set inactive elements of zd.T to 0, whereas the
    combined form would copy elements from zc.T.
    
    gcc/
            PR target/114603
            * config/aarch64/aarch64-sve.md (@aarch64_pred_cnot<mode>): Replace
            with...
            (@aarch64_ptrue_cnot<mode>): ...this, requiring operand 1 to be
            a ptrue.
            (*cnot<mode>): Require operand 1 to be a ptrue.
            * config/aarch64/aarch64-sve-builtins-base.cc (svcnot_impl::expand):
            Use aarch64_ptrue_cnot<mode> for _x operations that are predicated
            with a ptrue.  Represent other _x operations as fully-defined _m
            operations.
    
    gcc/testsuite/
            PR target/114603
            * gcc.target/aarch64/sve/acle/general/cnot_1.c: New test.
    
    (cherry picked from commit 67cbb1c638d6ab3a9cb77e674541e2b291fb67df)

diff --git a/gcc/config/aarch64/aarch64-sve-builtins-base.cc b/gcc/config/aarch64/aarch64-sve-builtins-base.cc
index e5e0d6ed5c9..f96cb3ccc7b 100644
--- a/gcc/config/aarch64/aarch64-sve-builtins-base.cc
+++ b/gcc/config/aarch64/aarch64-sve-builtins-base.cc
@@ -494,15 +494,22 @@ public:
   expand (function_expander &e) const OVERRIDE
   {
     machine_mode mode = e.vector_mode (0);
-    if (e.pred == PRED_x)
-      {
-	/* The pattern for CNOT includes an UNSPEC_PRED_Z, so needs
-	   a ptrue hint.  */
-	e.add_ptrue_hint (0, e.gp_mode (0));
-	return e.use_pred_x_insn (code_for_aarch64_pred_cnot (mode));
-      }
-
-    return e.use_cond_insn (code_for_cond_cnot (mode), 0);
+    machine_mode pred_mode = e.gp_mode (0);
+    /* The underlying _x pattern is effectively:
+
+	 dst = src == 0 ? 1 : 0
+
+       rather than an UNSPEC_PRED_X.  Using this form allows autovec
+       constructs to be matched by combine, but it means that the
+       predicate on the src == 0 comparison must be all-true.
+
+       For simplicity, represent other _x operations as fully-defined _m
+       operations rather than using a separate bespoke pattern.  */
+    if (e.pred == PRED_x
+	&& gen_lowpart (pred_mode, e.args[0]) == CONSTM1_RTX (pred_mode))
+      return e.use_pred_x_insn (code_for_aarch64_ptrue_cnot (mode));
+    return e.use_cond_insn (code_for_cond_cnot (mode),
+			    e.pred == PRED_x ? 1 : 0);
   }
 };
 
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/general/cnot_1.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/cnot_1.c
new file mode 100644
index 00000000000..b1a489f0cf0
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/cnot_1.c
@@ -0,0 +1,23 @@
+/* { dg-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
+
+#include <arm_sve.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+** foo:
+**	cmpeq	(p[0-7])\.s, p0/z, z0\.s, #0
+**	mov	z0\.s, \1/z, #1
+**	ret
+*/
+svint32_t foo(svbool_t pg, svint32_t y)
+{
+  return svsel(svcmpeq(pg, y, 0), svdup_s32(1), svdup_s32(0));
+}
+
+#ifdef __cplusplus
+}
+#endif

